﻿using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace Flex_Grid_Sorting
{
    public partial class Form1 : Form
    {
        DataTable mainTable = new DataTable();                                      
        DataTable tempTable = new DataTable();                                      //Temporary Table to be operated
        DataTable tempNumTable;                                                     //Temporary Table to store numbers only
        System.Data.DataRow tempRow1, tempRow2;                                     
        string resultString, subjectString;
        int temp, sortingCount = 0; 
        
        public Form1()
        {
            InitializeComponent();
            mainTable.Columns.Add("CustomerID", typeof(string));
            mainTable.Columns.Add("Name", typeof(string));
            mainTable.Columns.Add("Department", typeof(string));
            mainTable.Columns.Add("Designation", typeof(string));
            mainTable.Columns.Add("Country", typeof(string));

            mainTable.Rows.Add("13IND452APP56", "Mohit", "Apps", "Tester", "India");
            mainTable.Rows.Add("12USA534MAN45", "John", "Maintenance", "Electrician", "USA");
            mainTable.Rows.Add("13USA457ACC42", "Mark", "Accounts", "Accountant", "USA");
            mainTable.Rows.Add("11JPN426MAN75", "Koizumi", "Maintenance", "Guard", "Japan");
            mainTable.Rows.Add("14RUS782APP26", "Medvedev", "Apps", "Engineer", "Russia");
            mainTable.Rows.Add("13JPN459ACC56", "Atoyama", "Accounts", "Clerk", "Japan");
            mainTable.Rows.Add("11CHN716HRD72", "Yuanchao", "Human Resources", "Manager", "China");
            mainTable.Rows.Add("12IND791ACC76", "Sonu", "Accounts", "Accountant", "India");
            mainTable.Rows.Add("13RUS462HRD94", "Siluanov", "Human Resources", "Coordinator", "Russia");
            mainTable.Rows.Add("11USA426APP79", "Paul", "Apps", "Tester", "USA");
            mainTable.Rows.Add("14JPN424MAN82", "Yoshihiko", "Maintenance", "Gaurd", "Japan");
            mainTable.Rows.Add("14JPN452ACC34", "Yukio", "Accounts", "Clerk", "Japan");
            mainTable.Rows.Add("11RUS777HRD94", "Ulyukaev", "Human Resources", "Manager", "Russia");
            mainTable.Rows.Add("14IND722APP17", "Shubham", "Apps", "Engineer", "India");
            mainTable.Rows.Add("11CHN782MAN93", "Jinping", "Maintenance", "Electrician", "China");
            mainTable.Rows.Add("12RUS786HRD19", "Novak", "Human Resources", "Coordinator", "Russia");
            mainTable.Rows.Add("11CHN450ACC72", "Zhang", "Accounts", "Clerk", "China");

            tempTable = mainTable.Copy();                                               //Sample Data
            c1FlexGrid1.BeforeSort += c1FlexGrid1_BeforeSort;
            c1FlexGrid1.AfterSort += c1FlexGrid1_AfterSort;
        }

        void c1FlexGrid1_AfterSort(object sender, C1.Win.C1FlexGrid.SortColEventArgs e)
        {
            if (e.Col == 1)
            {
                e.Cancel = true;                                                        //For supressing default sorting behaviour
            }
        }

        void c1FlexGrid1_BeforeSort(object sender, C1.Win.C1FlexGrid.SortColEventArgs e)
        {
            tempTable = mainTable.Copy();
            tempNumTable = new DataTable();
            tempNumTable.Columns.Add("NumberInCustomerID", typeof(int));

            if (e.Col == 1)
            {
                for (int row = 0; row < tempTable.Rows.Count; row++)
                {
                    subjectString = tempTable.Rows[row].ItemArray[0].ToString();
                    resultString = System.Text.RegularExpressions.Regex.Replace(subjectString, @"\D", "");          //For taking out numerical data
                    tempNumTable.Rows.Add(Convert.ToInt32(resultString));
                }

                if(sortingCount % 2 == 0)                                                                           //For Ascending Sorting
                {
                    for (int i = 0; i < tempNumTable.Rows.Count ; i++)
                    {
                        for (int j = 0; j < tempNumTable.Rows.Count - 1 - i ; j++)
                        {
                            if (Convert.ToInt32(tempNumTable.Rows[j].ItemArray[0]) > Convert.ToInt32(tempNumTable.Rows[j + 1].ItemArray[0]))
                            {
                                temp = Convert.ToInt32(tempNumTable.Rows[j + 1][0]);
                                tempNumTable.Rows[j + 1][0] = tempNumTable.Rows[j][0];
                                tempNumTable.Rows[j][0] = temp;

                                tempRow1 = tempTable.NewRow();                                  //Temporary Rows used for swapping
                                tempRow2 = tempTable.NewRow();
                                tempRow1.ItemArray = tempTable.Rows[j].ItemArray;
                                tempRow2.ItemArray = tempTable.Rows[j+1].ItemArray;
                                tempTable.Rows.RemoveAt(j);
                                tempTable.Rows.RemoveAt(j);
                                tempTable.Rows.InsertAt(tempRow2, j);
                                tempTable.Rows.InsertAt(tempRow1, j + 1);
                            }
                        }
                    }
                }

                else if (sortingCount % 2 != 0)                                                                     //For Decending Sorting
                {
                 for (int i = 0; i < tempNumTable.Rows.Count; i++)
                    {
                        for (int j = 0; j < tempNumTable.Rows.Count - 1 - i; j++)
                        {
                            if (Convert.ToInt32(tempNumTable.Rows[j].ItemArray[0]) < Convert.ToInt32(tempNumTable.Rows[j + 1].ItemArray[0]))
                            {
                                temp = Convert.ToInt32(tempNumTable.Rows[j + 1][0]);
                                tempNumTable.Rows[j + 1][0] = tempNumTable.Rows[j][0];
                                tempNumTable.Rows[j][0] = temp;

                                tempRow1 = tempTable.NewRow();
                                tempRow2 = tempTable.NewRow();
                                tempRow1.ItemArray = tempTable.Rows[j].ItemArray;
                                tempRow2.ItemArray = tempTable.Rows[j + 1].ItemArray;
                                tempTable.Rows.RemoveAt(j);
                                tempTable.Rows.RemoveAt(j);
                                tempTable.Rows.InsertAt(tempRow2, j);
                                tempTable.Rows.InsertAt(tempRow1, j + 1);
                            }
                        }
                    }
                    e.Cancel = true;                                                    //For supressing default sorting behaviour
                }
                ++sortingCount;
                e.Cancel = true;                                                      //For supressing default sorting behaviour
                c1FlexGrid1.DataSource = tempTable;
            }
            c1FlexGrid1.Cols[1].StyleNew.BackColor = Color.LightBlue;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           c1FlexGrid1.DataSource = tempTable;
           c1FlexGrid1.Cols[1].AllowSorting = true;
           c1FlexGrid1.Styles.Fixed.BackColor = Color.LightGreen;
           c1FlexGrid1.Cols[1].StyleNew.BackColor = Color.LightBlue;
        }
    }
}
